
int max_num = 255;
int max_pixels = 15;
uint16_t i;
void Random() {
  // Set the values

  // Blackout first
  for(i=0; i<strip_a.numPixels(); i++) 
  {
    strip_a.setPixelColor(i, strip_a.Color(0,0,0,0));
    strip_b.setPixelColor(i, strip_b.Color(0,0,0,0));
  }
  i = 0;
  while (i < max_pixels)
  {
    strip_a.setPixelColor(random(NUM_LEDS), strip_a.Color(random(max_num),random(max_num),random(max_num), 0) );
    strip_b.setPixelColor(random(NUM_LEDS), strip_b.Color(random(max_num),random(max_num),random(max_num), 0) );
    i++;
  }
  /*
  for(uint16_t i=0; i<strip_a.numPixels(); i++) 
  {
    strip_a.setPixelColor(i, strip_a.Color(random(max_num),random(max_num),random(max_num), 0) );
    strip_b.setPixelColor(i, strip_b.Color(random(max_num),random(max_num),random(max_num), 0) );
  }
  */
  strip_a.show();
  strip_b.show();
  delay(50);
  
}





int animation_index = 0;
int animation_index_max = 90;
int startOfStripATopOfHelmet = 11;
int startOfStripBTopOfHelmet = 11;
int leftBrightness = 0;
int rightBrightness = 0;
// Beat left (A), then right (B) side, swapped for front. 
// Fade up between contractions
void HeartBeat() {
  
  if (animation_index == 10)
  {
    // Contract left side
    leftBrightness = 255;
  }
  else if (animation_index == 12)
  {
    leftBrightness = 128;
  }
  else if (animation_index == 14)
  {
    leftBrightness = 0;
  }
  else if (animation_index > 14 && animation_index < 70)
  {
    rightBrightness += 3;
    leftBrightness += 1;
  }
  else if (animation_index == 70)
  {
    rightBrightness = 255;
  }
  else if (animation_index == 72)
  {
    rightBrightness = 128;
  }
  else if (animation_index == 74)
  {
    rightBrightness = 0;
  }
  else 
  {
    leftBrightness += 1;
    /*
    for (int i = 0; i < leftBrightness; i++)
    {
      digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
      delay(20);               // wait for a second
      digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
      delay(20);               // wait for a second
    }
    delay(100);               // wait for a second
    */
  }
  

  animation_index++;
  if (animation_index == animation_index_max)
  {
    animation_index = 0;
  }

  // Set the values
  for(uint16_t i=0; i<strip_a.numPixels(); i++) {
    
    // Fade on red only for now
    if (i < startOfStripATopOfHelmet)
    {
      strip_a.setPixelColor(i, strip_a.Color(rightBrightness, 0, 0));
    }
    else
    {
      strip_a.setPixelColor(i, strip_a.Color(leftBrightness, 0, 0));
    }
    

    if (i < startOfStripBTopOfHelmet)
    {
      strip_b.setPixelColor(i, strip_b.Color(leftBrightness, 0, 0));
    }
    else
    {
      strip_b.setPixelColor(i, strip_b.Color(rightBrightness, 0, 0));
    }
    
  }
  strip_a.show();
  strip_b.show();
  
}
/*
int anim_index_max = 60;
int fadeBrightness = 0;
void HeartBeat2() {
  for (int16_t anim_index=0; anim_index < anim_index_max; anim_index += 1)
  {
    if (anim_index > anim_index_max-10)
    {
      fadeBrightness += 5;//(255-100)/8;
      fadeBrightness = max(fadeBrightness,255);
    }
    else
    {
      fadeBrightness -= 3;//9 * fadeBrightness / 10;
    }
    for(uint16_t i=0; i<strip_a.numPixels(); i++) {
      // Fade on red only for now
      strip_a.setPixelColor(i, strip_a.Color(fadeBrightness, 0, 0));
      strip_b.setPixelColor(i, strip_b.Color(fadeBrightness, 0, 0));
    }
    strip_a.show();
    strip_b.show();
  }
}
*/

/*
int anim_index = 0;
int anim_index_max = 100;
int16_t value = 0;
void noisyFadeBeats() {
  for (int16_t fade=0; fade < 90*2; fade+= 1) {
    
    if (anim_index == 45)
    {
      value = 255;
    }
    else
    {
      value = abs(120-fade) + 5;
    }
    
    value = abs(90-fade);
    for(uint16_t i=0; i<strip_a.numPixels(); i++) {
      // Fade on red only for now
      strip_a.setPixelColor(i, strip_a.Color(value, 0, 0));
      strip_b.setPixelColor(i, strip_b.Color(value, 0, 0));
    }
    strip_a.show();
    strip_b.show();
    anim_index++;
    if (anim_index == anim_index_max)
    {
      anim_index = 0;
    }
  }
}
*/


int anim_index = 0;
int anim_index_max = 100;
int16_t valueRed = 0;
int16_t valueWhite = 0;
void ambulance() {
  for (int16_t fade=0; fade < 90*2; fade+= 1) {
    
    if (anim_index > 30 && anim_index < 35)
    {
      valueRed = 255;
    }
    else if (anim_index > 45 && anim_index < 50)
    {
      valueRed = 255;
    }
    else if (anim_index > 80 && anim_index < 85)
    {
      valueWhite = 255;
    }
    else if (anim_index > 95 && anim_index < 100)
    {
      valueWhite = 255;
    }
    else
    {
      valueRed = 0;
      valueWhite = 0;
    }
    
    for(uint16_t i=0; i<strip_a.numPixels(); i+= 3) {
      // Fade on red only for now
      strip_a.setPixelColor(i, strip_a.Color(valueRed, 0, 0, valueWhite));
      strip_b.setPixelColor(i, strip_b.Color(valueRed, 0, 0, valueWhite));
    }
    strip_a.show();
    strip_b.show();
    anim_index++;
    if (anim_index == anim_index_max)
    {
      anim_index = 0;
    }
  }
}


void noisyFade() {
  for (int16_t fade=0; fade < 120*2; fade+= 1) {
    for(uint16_t i=0; i<strip_a.numPixels(); i++) {
      // Fade on red only for now
      strip_a.setPixelColor(i, strip_a.Color(abs(120-fade), 0, 0));
      strip_b.setPixelColor(i, strip_b.Color(abs(120-fade), 0, 0));
    }
    strip_a.show();
    strip_b.show();
  }
}
/*
void pulseWhite(uint8_t wait) {
  for(int j = 0; j < 256 ; j++){
      for(uint16_t i=0; i<strip.numPixels(); i++) {
          strip.setPixelColor(i, strip.Color(0,0,0, neopix_gamma[j] ) );
        }
        delay(wait);
        strip.show();
      }

  for(int j = 255; j >= 0 ; j--){
      for(uint16_t i=0; i<strip.numPixels(); i++) {
          strip.setPixelColor(i, strip.Color(0,0,0, neopix_gamma[j] ) );
        }
        delay(wait);
        strip.show();
      }
}


void rainbowFade2White(Adafruit_NeoPixel stripFoo, uint8_t wait, int rainbowLoops, int whiteLoops) {
  float fadeMax = 100.0;
  int fadeVal = 0;
  uint32_t wheelVal;
  int redVal, greenVal, blueVal;

  for(int k = 0 ; k < rainbowLoops ; k ++){
    
    for(int j=0; j<256; j++) { // 5 cycles of all colors on wheel

      for(int i=0; i< stripFoo.numPixels(); i++) {

        wheelVal = Wheel(((i * 256 / stripFoo.numPixels()) + j) & 255);

        redVal = red(wheelVal) * float(fadeVal/fadeMax);
        greenVal = green(wheelVal) * float(fadeVal/fadeMax);
        blueVal = blue(wheelVal) * float(fadeVal/fadeMax);

        stripFoo.setPixelColor( i, stripFoo.Color( redVal, greenVal, blueVal ) );

      }

      //First loop, fade in!
      if(k == 0 && fadeVal < fadeMax-1) {
          fadeVal++;
      }

      //Last loop, fade out!
      else if(k == rainbowLoops - 1 && j > 255 - fadeMax ){
          fadeVal--;
      }

        stripFoo.show();
        delay(wait);
    }
  
  }



  delay(500);


  for(int k = 0 ; k < whiteLoops ; k ++){

    for(int j = 0; j < 256 ; j++){

        for(uint16_t i=0; i < stripFoo.numPixels(); i++) {
            stripFoo.setPixelColor(i, stripFoo.Color(0,0,0, neopix_gamma[j] ) );
          }
          stripFoo.show();
        }

        delay(2000);
    for(int j = 255; j >= 0 ; j--){

        for(uint16_t i=0; i < stripFoo.numPixels(); i++) {
            stripFoo.setPixelColor(i, stripFoo.Color(0,0,0, neopix_gamma[j] ) );
          }
          stripFoo.show();
        }
  }

  delay(500);


}

void whiteOverRainbow(uint8_t wait, uint8_t whiteSpeed, uint8_t whiteLength ) {
  
  if(whiteLength >= strip.numPixels()) whiteLength = strip.numPixels() - 1;

  int head = whiteLength - 1;
  int tail = 0;

  int loops = 3;
  int loopNum = 0;

  static unsigned long lastTime = 0;


  while(true){
    for(int j=0; j<256; j++) {
      for(uint16_t i=0; i<strip.numPixels(); i++) {
        if((i >= tail && i <= head) || (tail > head && i >= tail) || (tail > head && i <= head) ){
          strip.setPixelColor(i, strip.Color(0,0,0, 255 ) );
        }
        else{
          strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
        }
        
      }

      if(millis() - lastTime > whiteSpeed) {
        head++;
        tail++;
        if(head == strip.numPixels()){
          loopNum++;
        }
        lastTime = millis();
      }

      if(loopNum == loops) return;
    
      head%=strip.numPixels();
      tail%=strip.numPixels();
        strip.show();
        delay(wait);
    }
  }
  
}
void fullWhite() {
  
    for(uint16_t i=0; i<strip.numPixels(); i++) {
        strip.setPixelColor(i, strip.Color(0,0,0, 255 ) );
    }
      strip.show();
}


// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256 * 5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3,0);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3,0);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0,0);
}
*/

